// PimalDateHelper.cpp: implementation of the PimalDateHelper class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "PimalDateHelper.h"

#include "PimalIntHelper.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// getDATE(): returns the Date as DATE as specified in the MS API
//////////////////////////////////////////////////////////////////////
DATE PimalDateHelper::getDATE()
{
	return dateAsDate;
}


//////////////////////////////////////////////////////////////////////
// getGenericDateString(): returns the Date as CString in the format JJJJ-MM-DD
//////////////////////////////////////////////////////////////////////

CString PimalDateHelper::getGenericDateString()
{
	return dateAsGenericDateString;
}

//////////////////////////////////////////////////////////////////////
// getGenericTimeString(); returns the Time as CString in the format: HH:MM:SS
//////////////////////////////////////////////////////////////////////

CString PimalDateHelper::getGenericTimeString()
{
	return timeAsGenericTimeString;
}


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PimalDateHelper::PimalDateHelper()
{
	
}

PimalDateHelper::PimalDateHelper(BSTR pimalDateHelperGenericDateString)
{
	CString tmp(pimalDateHelperGenericDateString);
	int day, month, year, hours, minutes, seconds;

   // yyyymmddThhmmssZ (ISO8601, local time)
   if (tmp.GetLength() == 16)
   {
      year    = PimalIntHelper(tmp.Mid(0,4)).getInt();
      month   = PimalIntHelper(tmp.Mid(4,2)).getInt();
      day     = PimalIntHelper(tmp.Mid(6,2)).getInt();
      hours   = PimalIntHelper(tmp.Mid(9,2)).getInt();
      minutes = PimalIntHelper(tmp.Mid(11,2)).getInt();
      seconds = PimalIntHelper(tmp.Mid(13,2)).getInt();
   	dateAsGenericDateString = tmp;
   }
   else // use the current date, not 1899!
   {
      SYSTEMTIME st;  // Win32 time information
      GetSystemTime(&st);
      year = st.wYear;
      month = st.wMonth;
      day = st.wDay;
      hours = st.wHour;
      minutes = st.wMinute;
      seconds = st.wSecond;
      dateAsGenericDateString.Format(_T("%04d%02d%02dT%02d%02d%02dZ"),year,month,day,hours,minutes,seconds);
   }
/*
GUICH NOTES: the string that was being transfered from Java was NOT ON THIS FORMAT!
The correct format is the <i>YYYYMMDD</i>T<i>hhmmss</i>Z (ISO8601, local time)
Also, this routine has a flaw: try to convert 100005 (time) - it won't work.

   // parsing through the String (which should be formatted like this: JJJJ-MM-DD HH:MM:SS otherwise there will be unexpected results)
	// and extracting year, month and day and time out of it
	for (int i=0; i<tmp.GetLength(); i++)
	{
		tmpChar = tmp.GetAt(i);

		if (tmpChar == '-')
		{
			PimalIntHelper tmpHelper(tmpSubstr);
			if ( year == 0) year = tmpHelper.getInt();
			else month = tmpHelper.getInt();

			tmpSubstr = "";
		}
		else if(tmpChar == ' ')
		{
				PimalIntHelper tmpHelper(tmpSubstr);
				day = tmpHelper.getInt();
				tmpSubstr = "";
		}
		else if(tmpChar = ':' || i+1 == tmp.GetLength())
		{
				PimalIntHelper tmpHelper(tmpSubstr);
				if (hours == 0) hours = tmpHelper.getInt();
				else if (minutes == 0) minutes = tmpHelper.getInt();
				else seconds = tmpHelper.getInt();
		}
		else 
		{
			tmpSubstr = tmpSubstr + tmpChar;
		}
	}
  */

	// with the gained Information we are able to create a COleDateTime Object
	COleDateTime dateAsCOleDateTimeTmp(year, month, day, hours, minutes, seconds);
	dateAsCOleDateTime = dateAsCOleDateTimeTmp;

	// the COleDateTimeObject can easily be changed to datatype DATE
	dateAsDate = DATE(dateAsCOleDateTime);

}

PimalDateHelper::PimalDateHelper(DATE initDate)
{
	dateAsDate = initDate;

	CString dateString, timeString;

	// creating a COleDateTime Object from datatype DATE
	COleDateTime dateAsCOleDateTimeTmp(dateAsDate);
	
	dateAsCOleDateTime = dateAsCOleDateTimeTmp;

	// converting it into JJJJ-MM-DD format (PimalDateHelperGenericDateString)
	int year = dateAsCOleDateTimeTmp.GetYear();
	int month = dateAsCOleDateTimeTmp.GetMonth();
	int day = dateAsCOleDateTimeTmp.GetDay();

	int hours = dateAsCOleDateTimeTmp.GetHour();
	int minutes = dateAsCOleDateTimeTmp.GetMinute();
	int seconds = dateAsCOleDateTimeTmp.GetSecond();

	if (year == 4501) 
	{ 
		dateString = ""; 
		timeString = "";
	}
	else 
	{ 
		dateString.Format(_T("%04d%02d%02d"), year, month, day); 
		timeString.Format(_T("%02d%02d%02d"), hours, minutes, seconds);	
	}

	dateAsGenericDateString = dateString;
	timeAsGenericTimeString = timeString;

}

PimalDateHelper::~PimalDateHelper()
{

}
