/*********************************************************************************
 *  SuperWaba Virtual Machine, version 5                                         *
 *  Copyright (C) 2000-2005 SuperWaba Ltda.                                      *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  Please see the software license located at /license.txt for more details.    *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     SuperWaba Ltda.                                                           *
 *     Rua Padre Leonel Franca, 480, sala 27A                                    *
 *     Instituto Genesis - PUC-RIO                                               *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22451-000                                                            *
 *     E-mail: licensing@superwaba.com.br                                        *
 *********************************************************************************/
/* $Id: SW_String.h,v 1.3 2005/09/25 12:56:34 guich Exp $ */

#ifdef __DEFINE_FUNCTIONS

#ifndef SW_STRING_H_INCLUDED
#define SW_STRING_H_INCLUDED
#include "SW_types.h"

int initString();
int32 toLowerCase(int32 c);
int32 toUpperCase(int32 c);
void unsigned2hex(int32 b, int32 places, char *c);
void StringToLowerCase(Var stack[]);
void StringToUpperCase(Var stack[]);
void StringBufferEnsureCapacity(Var stack[]);
void StringBufferSetLength(Var stack[]);
void appendString(Var stack[]);
void appendCharArray(Var stack[]);
void appendCharArrayOffLen(Var stack[]);
void appendChar(Var stack[]);
void appendInt(Var stack[]);
void appendFloat(Var stack[]);
void appendDouble(Var stack[]);
void valueOfDouble(Var stack[]);
void StringCopyChars(Var stack[]);
void StringEquals(Var stack[]);
void StringCompareTo(Var stack[]);
void indexOfChar(Var stack[]);
void indexOfCharStart(Var stack[]);
void StringIndexOf(Var stack[]);
void StringHashCode(Var stack[]);
WObject createString(char * buf);
WObject createStringFromCharPtr(char *s, int32 len);
WObject createStringObject();
WObject createStringFromUtf(UtfString s);
WObject createStringFromUnicode(TCHAR const * s, uint32 len);
void getUtfString2(WClass *wclass inA1, uint16 idx inD0, UtfString *s inA0); // Don't inline
UtfString createUtfString(char *buf);
UtfString getUtfString(WClass *wclass inA0, uint16 idx inD0);
UtfString16 stringToUtf16(WObject string);
UtfString stringToUtf(WObject str, byte flags);
void ObjectToStringNative(Var stack[]);

#endif
#endif
/*===========================================================================*/
