/*********************************************************************************
 *  SuperWaba Virtual Machine, version 5                                         *
 *  Copyright (C) 2000-2005 SuperWaba Ltda.                                      *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  Please see the software license located at /license.txt for more details.    *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     SuperWaba Ltda.                                                           *
 *     Rua Padre Leonel Franca, 480, sala 27A                                    *
 *     Instituto Genesis - PUC-RIO                                               *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22451-000                                                            *
 *     E-mail: licensing@superwaba.com.br                                        *
 *********************************************************************************/
/* $Id: SW_palmDb_palm.c,v 1.7 2005/09/09 14:08:14 guich Exp $ */

#include "superwaba.h"
#include "SW_palmDb.h"
#include "SW_logging.h"

//already in SW_defines, if it cannot be shared declare it static
//DmSearchStateType state;

static void* findAndOpenDB(char *name, ULong dbCreator, ULong dbType, byte readOnly)
{
   static char dbName[32];
   Boolean first;
   UInt cardNo;
   LocalID dbID;
   Err err;
   UInt16 attributes;

   //_LOG_INFO((LOG_CAT_DBM, "findDB(%s, 0x%x, 0x%x)", name, (int)dbCreator, (int)dbType));

   first = true;
   if (dbType == 'appl' || dbCreator == 'psys' || dbType == 'rsrc') return NULL; // guich@200b4_116: skip system files.
   while (1)
   {
      err = DmGetNextDatabaseByTypeCreator(first, &state,
         								dbType, dbCreator, false, PALM_CARD(&cardNo) &dbID);
      if (err == dmErrCantFind)
      {
         //_LOG_ERROR((LOG_CAT_DBM, "can't find!"));
         return NULL;
      }
      if (DmDatabaseInfo(PALM_CARD(cardNo) dbID, dbName, &attributes,
         				NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL) == 0)
      {
         //_LOG_DEBUG((LOG_CAT_DBM, "test db==%s", dbName ? dbName:"noname"));
         if ((attributes & dmHdrAttrResDB) == 0 // guich@200b4_116: skip resource databases
            && !StrCompare(name, dbName))
         {
            //_LOG_DEBUG((LOG_CAT_DBM, "found!"));
            return DmOpenDatabase(PALM_CARD(cardNo) dbID, dmModeReadWrite);
         }
      }
      first = false;
   }
}

void setPalmDBProcs(struct VMGlobals * vmGlobals)
{
   vmGlobals->findAndOpenDB = findAndOpenDB;
}

/*===========================================================================*/
