/*********************************************************************************
 *  SuperWaba Virtual Machine, version 5                                         *
 *  Copyright (C) 2000-2005 SuperWaba Ltda.                                      *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  Please see the software license located at /license.txt for more details.    *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     SuperWaba Ltda.                                                           *
 *     Rua Padre Leonel Franca, 480, sala 27A                                    *
 *     Instituto Genesis - PUC-RIO                                               *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22451-000                                                            *
 *     E-mail: licensing@superwaba.com.br                                        *
 *********************************************************************************/
/* $Id: epoc_dll.cpp,v 1.2 2005/10/20 00:08:48 fdie Exp $ */

#include <e32std.h>
#include "epoc_dll.h"

struct LibraryData
{
    RLibrary *lib;
    void *globals;
};

void *LoadLibrary(const char *p)
{    
   LibraryData *data = new (ELeave) LibraryData;
   data->lib = new (ELeave) RLibrary;
   data->globals = NULL;

   TFileName fname;
   fname.Copy(TPtrC8((const TUint8 *)p));

   if (data->lib->Load(fname) != KErrNone)
   {
      data->lib->Close();
      delete data->lib;
      delete data;
      data = NULL;
   }   
   return data;
}

void *GetProcAddress(const void *p, int ordinal)
{
   RLibrary *lib = ((struct LibraryData*)p)->lib;
   if (lib == NULL) return NULL;
   return lib->Lookup(ordinal);
}

/*============================================================================*/
