/* $Id: epoc_startupApp.cpp,v 1.8 2004/10/18 06:13:37 petrus Exp $ */

#include <eikenv.h>
#include <eikappui.h>
#include <eikapp.h>
#include <eikdoc.h>
#include <eikdll.h>
#include <f32file.h>
#include "epoc_startup.h"

const TUid KUidSuperWabaApp = { SUPERWABA_APP_UID };
_LIT(KSuperWabaFilePath, "\\System\\Apps\\SuperWaba\\");

#if defined(__WINS__)
_LIT(KSuperWabaFileName, "SuperWaba.dll");
#else
_LIT(KSuperWabaFileName, "SuperWaba.exe");
#endif

// if you enjoy macros, please, be my guest!
#define MAKE_CMDLINE_1(b) MAKE_CMDLINE_2(b)
#if defined(_UNICODE)
#define MAKE_CMDLINE_2(b) L ## "SuperWaba~" L ## #b
static const TLitC<sizeof(MAKE_CMDLINE_1(SUPERWABA_APP_ARG))/2> KCmdLine = {
   sizeof(MAKE_CMDLINE_1(SUPERWABA_APP_ARG))/2 - 1,
   MAKE_CMDLINE_1(SUPERWABA_APP_ARG)
};
#else
#define MAKE_CMDLINE_2(b) "SuperWaba~" #b
static const TLitC<sizeof(MAKE_CMDLINE_1(SUPERWABA_APP_ARG))> KCmdLine = {
   sizeof(MAKE_CMDLINE_1(SUPERWABA_APP_ARG)) - 1,
   MAKE_CMDLINE_1(SUPERWABA_APP_ARG)
};
#endif

class SuperWabaAppUi : public CEikAppUi
{
private:
   #if defined __WINS__
   TInt startSuperWabaExe()
   {
      TInt err;
      RFs fileServer; // File server session

      err = fileServer.Connect();
      if (KErrNone == err) {
         TFindFile fileFinder(fileServer);
         err = fileFinder.FindByDir(KSuperWabaFileName, KSuperWabaFilePath);
         if (err == KErrNone) {
            EikDll::StartExeL(fileFinder.File());
         }
         fileServer.Close();
      }
      return err;
   }

   #else
   TInt createSuperWabaProcess(RProcess & server)
   {
      TInt err;
      RFs fileServer; // File server session

      err = fileServer.Connect();
      if (KErrNone == err) {
         TFindFile fileFinder(fileServer);
         err = fileFinder.FindByDir(KSuperWabaFileName, KSuperWabaFilePath);
         if (err == KErrNone) {
            err = server.Create(
               fileFinder.File(),
               KCmdLine(),
               TUidType(KNullUid, KNullUid, KNullUid),
               EOwnerThread
            );
         }
         fileServer.Close();
      }
      return err;
   }
   #endif

public:
   void ConstructL()
   {
   #if defined __WINS__
      RChunk chunk;
      RSemaphore semReady;
      TInt cmdLineLen = KCmdLine().Length() * sizeof(TText);
      unsigned char const * src = (unsigned char const *)KCmdLine().Ptr();
      unsigned char * tgt;

      chunk.CreateGlobal(KSuperWabaUid, cmdLineLen + sizeof(TText), cmdLineLen + sizeof(TText));
      tgt = chunk.Base();
      while (cmdLineLen--) {
         *tgt++ = *src++;
      }
      *((TText *)tgt) = (TText)0;
      semReady.CreateGlobal(KSuperWabaUid, 0);
      startSuperWabaExe();
      semReady.Wait();           // wait until done
      semReady.Close();
      chunk.Close();
      User::Exit(0);
   #else
      RProcess server;
      if (KErrNone == createSuperWabaProcess(server))
      {
         TRequestStatus status;
         server.Resume();
         server.Close();
         User::WaitForRequest(status); // wait for launch to complete
      }
      User::Exit(0);
   #endif
   }

   ~SuperWabaAppUi() {
   }

private:
   void HandleCommandL(TInt) {
   }

};

class SuperWabaDocument : public CEikDocument
{
public:
   static SuperWabaDocument* NewL(CEikApplication& aApp);
   SuperWabaDocument(CEikApplication& aApp) : CEikDocument(aApp) {}
   void ConstructL();
private:
   CEikAppUi* CreateAppUiL() {
      return new (ELeave) SuperWabaAppUi;
   }
};

class SuperWabaApplication : public CEikApplication
{
private:
   CApaDocument* CreateDocumentL() {
      return new (ELeave) SuperWabaDocument(*this);
   }
   TUid AppDllUid() const {
      return KUidSuperWabaApp;
   }
};

EXPORT_C CApaApplication * NewApplication() {
   return new SuperWabaApplication;
}

GLDEF_C TInt E32Dll(TDllReason) {
   return KErrNone;
}

/*===========================================================================*/
