/*********************************************************************************
 *  SuperWaba Virtual Machine, version 5                                         *
 *  Copyright (C) 2000-2005 SuperWaba Ltda.                                      *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  Please see the software license located at /license.txt for more details.    *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     SuperWaba Ltda.                                                           *
 *     Rua Padre Leonel Franca, 480, sala 27A                                    *
 *     Instituto Genesis - PUC-RIO                                               *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22451-000                                                            *
 *     E-mail: licensing@superwaba.com.br                                        *
 *********************************************************************************/

// this file is needed bc some methods are implemented in nmpalm_c.c and
// others in Graphic.c
#ifndef __NMPALM_C_H
#define __NMPALM_C_H

void ConvertToString_Char(Var stack[]);
void ConvertToString_Int(Var stack[]);
void ConvertToString_Float(Var stack[]);
void GraphicsDrawDottedCursor(Var stack[]);
void GraphicsCopyImageRect(Var stack[]);
void GraphicsCopyScreen(Var stack[]);
void GraphicsDrawImageSprite(Var stack[]);
void GraphicsCreate(Var stack[]);
void GraphicsDrawEllipse(Var stack[]);
void GraphicsFillEllipse(Var stack[]);
void GraphicsDrawArc(Var stack[]);
void GraphicsDrawPie(Var stack[]);
void GraphicsFillPie(Var stack[]);
void GraphicsDrawEllipticalArc(Var stack[]);
void GraphicsDrawEllipticalPie(Var stack[]);
void GraphicsFillEllipticalPie(Var stack[]);
void GraphicsDrawCircle(Var stack[]);
void GraphicsFillCircle(Var stack[]);
void GraphicsGetPixel(Var stack[]);
void GraphicsSetPixel(Var stack[]);
void GraphicsEraseRect(Var stack[]);
void GraphicsDrawLine(Var stack[]);
void GraphicsClearScreen(Var stack[]);
void GraphicsDrawDots(Var stack[]);
void GraphicsDrawCursor(Var stack[]);
void GraphicsDrawCursorOutline(Var stack[]);
void GraphicsDrawRect(Var stack[]);
void GraphicsFillRect(Var stack[]);
void GraphicsDrawDottedRect(Var stack[]);
void GraphicsFillPolygon(Var stack[]);
void GraphicsDrawPolygon(Var stack[]);
void GraphicsDrawPolyline(Var stack[]);
void GraphicsGetAnglePoint(Var stack[]);
void GraphicsDrawText(Var stack[]);
void GraphicsDrawTextChars(Var stack[]);
void GraphicsDrawHatchedRect(Var stack[]);
void GraphicsFillHatchedRect(Var stack[]);
void GraphicsDrawRoundRect(Var stack[]);
void GraphicsFillRoundRect(Var stack[]);
void GraphicsSetClip(Var stack[]);
void GraphicsGetClip(Var stack[]);
void GraphicsClip(Var stack[]);
void GraphicsClearClip(Var stack[]);
void GraphicsTranslate(Var stack[]);
void GraphicsGetTranslation(Var stack[]);
void GraphicsCopyRect(Var stack[]);
void GraphicsFree(Var stack[]);
void GraphicsSetForeColor(Var stack[]);
void GraphicsSetBackColor(Var stack[]);
void GraphicsCollisionDetect(Var stack[]);
void Graphics_applyPalette(Var stack[]);
void GraphicsDrawHighLightFrame(Var stack[]);
void GraphicsSetFont(Var stack[]);
void FileSetAttributes(Var stack[]);
void FileGetAttributes(Var stack[]);
void FileSetTime(Var stack[]);
void FileGetTime(Var stack[]);
void FileIsAvailable(Var stack[]);
void FileCreate(Var stack[]);
void FileIsInserted(Var stack[]);
void FileClose_(Var stack[]);
void FileCreateDir(Var stack[]);
void FileDelete_(Var stack[]);
void FileExists(Var stack[]);
void FileGetSize(Var stack[]);
void FileIsDir(Var stack[]);
void FileIsOpen(Var stack[]);
void FileListFiles(Var stack[]);
void FileReadBytes(Var stack[]);
void FileRename(Var stack[]);
void FileSetPos(Var stack[]);
void FileWriteBytes(Var stack[]);
void FontCreate(Var stack[]);
void FontMetricsCreate(Var stack[]);
void FontMetricsGetCharWidth(Var stack[]);
void FontMetricsGetTextWidth_String(Var stack[]);
void FontMetricsGetTextWidth(Var stack[]);
void PaletteGetCurrentPalette(Var stack[]);
void ImageCreate(Var stack[]);
void ImageGetScaledInstance(Var stack[]);
void ImageLoad(Var stack[]);
void ImageParse(Var stack[]);
void ImageFree(Var stack[]);
void ImageChangeColors(Var stack[]);
void ImageGetPixelRow(Var stack[]);
void ImageGetRotatedScaledInstance(Var stack[]);
void ImageGetTouchedUpInstance(Var stack[]);
void SoundBeep(Var stack[]);
void SoundTone(Var stack[]);
void SoundSetEnabled(Var stack[]);
void SoundClipPlay(Var stack[]);
void SoundClipFree(Var stack[]);
void SerialPortCreate(Var stack[]);
void SerialPortClose(Var stack[]);
void SerialPortIsOpen(Var stack[]);
void SerialPortSetFlowControl(Var stack[]);
void SerialPortSetReadTimeout(Var stack[]);
void SerialPortReadBytes(Var stack[]);
void SerialPortReadCheck(Var stack[]);
void SerialPortWriteBytes(Var stack[]);
void SocketCreate(Var stack[]);
void SocketClose(Var stack[]);
void SocketIsOpen(Var stack[]);
void SocketSetReadTimeout(Var stack[]);
void SocketReadBytes(Var stack[]);
void SocketWriteBytes(Var stack[]);
void SocketDisconnect(Var stack[]);
void CatalogCreate(Var stack[]);
void CatalogRename(Var stack[]);
void CatalogAddRecord(Var stack[]);
void CatalogAddRecord2(Var stack[]);
void CatalogResizeRecord(Var stack[]);
void CatalogClose(Var stack[]);
void CatalogDelete(Var stack[]);
void CatalogListCatalogs(Var stack[]);
void CatalogDeleteRecord(Var stack[]);
void CatalogGetRecordCount(Var stack[]);
void CatalogGetRecordSize(Var stack[]);
void CatalogIsOpen(Var stack[]);
void CatalogSetRecordPos(Var stack[]);
void CatalogReadBytes(Var stack[]);
void CatalogSkipBytes(Var stack[]);
void CatalogWriteBytes(Var stack[]);
void CatalogInspectRecord(Var stack[]);
void CatalogGetRecordAttributes(Var stack[]);
void CatalogSetRecordAttributes(Var stack[]);
void CatalogGetAttributes(Var stack[]);
void CatalogSetAttributes(Var stack[]);
void CatalogGetRecordPos(Var stack[]);
void CatalogCreate_NoFunc(Var stack[]);
void ConvertUnsigned2hex(Var stack[]);
void ConvertToLowerCase(Var stack[]);
void ConvertToUpperCase(Var stack[]);
void ConvertToInt(Var stack[]);
void ConvertToString_Char(Var stack[]);
void ConvertToIntBitwise(Var stack[]);
void ConvertToFloatBitwise(Var stack[]);
void ConvertToString_Float(Var stack[]);
void ConvertToString_Int(Var stack[]);
void ConvertToString_Double(Var stack[]);
void ConvertToDouble(Var stack[]);
void ConvertToString_Float_Int(Var stack[]);
void ConvertToFloat(Var stack[]);
void ConvertToString_String_Int(Var stack[]);
void ConvertDoubleToLongBits(Var stack[]);
void ConvertDoubleFromLongBits(Var stack[]);
void TimeCreate(Var stack[]);
void VmGetFile(Var stack[]);
void VmGetRemainingBattery(Var stack[]);
void VmGetTimeStamp(Var stack[]);
void VmSetTimeStamp(Var stack[]);
void VmExitAndReboot(Var stack[]);
void VmGC(Var stack[]);
void VmExec(Var stack[]);
void VmSetDeviceAutoOff(Var stack[]);
void VmSleep(Var stack[]);
void VmGetDeviceFreeMemory(Var stack[]);
void VmInterceptSystemKeys(Var stack[]);
void VmDebug(Var stack[]);
void VmClipboardCopy(Var stack[]);
void VmClipboardPaste(Var stack[]);
void VmAttachLibrary(Var stack[]);
void VmAttachNativeLibrary(Var stack[]);
void VmGetSystemKeysPressed(Var stack[]);
void WindowCreate(Var stack[]);
void WindowSetStatePosition(Var stack[]);
void MainWindowCreate(Var stack[]);
void MainWindowExit(Var stack[]);
void MainWindowSetTimerInterval(Var stack[]);
void MainWindowGetCommandLine(Var stack[]);
void MainWindowSetThreadCount(Var stack[]);
void EventIsAvailable(Var stack[]);
void WindowPumpEvents(Var stack[]);
void WindowUpdateScreen(Var stack[]);

#endif