/*********************************************************************************
 *  SuperWaba Virtual Machine, version 5                                         *
 *  Copyright (C) 2000-2005 SuperWaba Ltda.                                      *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  Please see the software license located at /license.txt for more details.    *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     SuperWaba Ltda.                                                           *
 *     Rua Padre Leonel Franca, 480, sala 27A                                    *
 *     Instituto Genesis - PUC-RIO                                               *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22451-000                                                            *
 *     E-mail: licensing@superwaba.com.br                                        *
 *********************************************************************************/

//////////////////////////////////////////////////////////////////////////
// waba/sys/NativeMethods static String convertUnsigned2hex(int b, int places)
void ConvertUnsigned2hex(Var stack[]) // (II)Ljava/lang/String;
{
   char buf[9];
	uint32 b = stack[0].intValue;
	int places = stack[1].intValue;
   vmGlobals->unsigned2hex(b,places,buf);
   RETURN32(vmGlobals->createStringFromCharPtr(buf,places))
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/NativeMethods static char convertToLowerCase(char c)
void ConvertToLowerCase(Var stack[]) // (C)C
{
	RETURN32(vmGlobals->toLowerCase(stack[0].intValue))
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/NativeMethods static char convertToUpperCase(char c)
void ConvertToUpperCase(Var stack[]) // (C)C
{
	RETURN32(vmGlobals->toUpperCase(stack[0].intValue))
}
//////////////////////////////// Math ////////////////////////////////////
/*inline static void copy64(Var *src, Var *dest)
{
   *dest = *src;
   *(dest+1) = *(src+1);
} */
static FlpCompDouble stack2double(Var stack) // internal use only
{
	UtfString s;
	FlpCompDouble fDouble;

	fDouble.d = 0;
	s = (*vmGlobals->stringToUtf)(stack.obj, STU_USE_STATIC | STU_NULL_TERMINATE);
	if (s.len > 0) // ATT: FlpAToF has a flaw! if u convert 54321.9876543 using it returns invalid result!
  	   fDouble.d = (*vmGlobals->str2double)(s.str);
  	return fDouble;
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Convert static int convertToInt(String s)
void ConvertToInt(Var stack[]) // (Ljava/lang/String;)I
{
	WObject string = stack[0].obj;
	UtfString s = (*vmGlobals->stringToUtf)(string, STU_USE_STATIC | STU_NULL_TERMINATE);
	int32 ret = 0;
	if (s.len > 0)
	   ret = (int32)(*vmGlobals->str2int32)(s.str);
	RETURN32(ret)
}
//////////////////////////////////////////////////////////////////////////
// guich@200: corrected to correctly handle international chars
// waba/sys/Convert static String convertToString(char c)
void ConvertToString_Char(Var stack[]) // (C)Ljava/lang/String;
{
   WObject obj, charArrayObj;
   uint16 *charStart;
   int len = 1;

   // create and fill char array
   charArrayObj = (*vmGlobals->createArrayObject)(5, len);
   if (!charArrayObj)
      RETURN32(0)
   if ((*vmGlobals->pushObject)(charArrayObj) == -1)
      RETURN32(0)
   charStart = (uint16 *)WOBJ_arrayStart(charArrayObj);
   charStart[0] = (uint16)stack[0].intValue;
   // create String object and set char array
   obj = (*vmGlobals->createStringObject)();
   if (obj != 0)
      WOBJ_StringCharArrayObj(obj) = charArrayObj;
   (*vmGlobals->popObject)(); // charArrayObj
   RETURN32(obj)
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Convert static int convertToIntBitwise(float f)
void ConvertToIntBitwise(Var stack[]) // (F)I
{
	RETURN32(stack[0].intValue)
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Convert static float convertToFloatBitwise(int i)
void ConvertToFloatBitwise(Var stack[]) // (I)F
{
	RETURN32(stack[0].intValue)
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Convert static String convertToString(float f)
void ConvertToString_Float(Var stack[]) // (F)Ljava/lang/String;
{
   RETURN32((*vmGlobals->float2str)(stack[0].floatValue))
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Convert static String convertToString(int i)
void ConvertToString_Int(Var stack[]) // (I)Ljava/lang/String;
{
	RETURN32((*vmGlobals->createString)((*vmGlobals->intToString)(stack[0].intValue)))
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Convert static String convertToString(double d, int precision)
void ConvertToString_Double(Var stack[]) // (DI)Ljava/lang/String;
{
   double d;
   copy64(stack,(Var*)&d);
   RETURN32((*vmGlobals->double2str)(d,(int)stack[2].intValue))
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Convert static double convertToDouble(String s)
void ConvertToDouble(Var stack[]) // (Ljava/lang/String;)D
{
	UtfString s;
	double d=0; // guich@400_80: forgot to initialize this to 0.
	s = (*vmGlobals->stringToUtf)(stack[0].obj, STU_USE_STATIC | STU_NULL_TERMINATE);
	if (s.len > 0) // ATT: FlpAToF has a flaw! if u convert 54321.9876543 using it returns invalid result!
  	   d = (*vmGlobals->str2double)(s.str);
  	RETURN64_FROM_VALUE(d)
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Convert static String convertToString(float f, int d)
void ConvertToString_Float_Int(Var stack[]) // (FI)Ljava/lang/String;
{
   RETURN32((*vmGlobals->double2str)((double)stack[0].floatValue,(int)stack[1].intValue))
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Convert static float convertToFloat(String s)
void ConvertToFloat(Var stack[]) // (Ljava/lang/String;)F
{
	RETURN32_FLOAT((float32)stack2double(stack[0]).d)
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Convert static String convertToString(String doubleValue, int n)
void ConvertToString_String_Int(Var stack[]) // (Ljava/lang/String;I)Ljava/lang/String;
{
   RETURN32((*vmGlobals->double2str)(stack2double(stack[0]).d,(int)stack[1].intValue))
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Convert static long convertDoubleToLongBits(double value)
void ConvertDoubleToLongBits(Var stack[]) // (D)J
{
   store64(stack,stack); // just return the values
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Convert static double convertLongBitsToDouble(long bits)
void ConvertDoubleFromLongBits(Var stack[]) // (J)D
{
   store64(stack,stack); // just return the values
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Time static void timeCreate(Time obj)
void TimeCreate(Var stack[]) // (Lwaba/sys/Time;)V
{
	WObject time;
	DateTimeType nowTM;

	time = stack[0].obj;
	TimSecondsToDateTime(TimGetSeconds(), &nowTM);
	WOBJ_TimeYear(time) = nowTM.year;
	WOBJ_TimeMonth(time) = nowTM.month;
	WOBJ_TimeDay(time) = nowTM.day;
	WOBJ_TimeHour(time) = nowTM.hour;
	WOBJ_TimeMinute(time) = nowTM.minute;
	WOBJ_TimeSecond(time) = nowTM.second;
	WOBJ_TimeMillis(time) = (*vmGlobals->getTimeStamp)() % 1000; // guich@200b4_139
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Vm static int vmGetTimeStamp()
void VmGetTimeStamp(Var stack[]) // ()I
{
	RETURN32((*vmGlobals->getTimeStamp)())
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/NativeMethods static void vmSetTimeStamp(waba.sys.Time t)
void VmSetTimeStamp(Var stack[]) // (Lwaba/sys/Time;)V
{
	WObject time = stack[0].obj;
	DateTimeType now;
	int32 seconds;
	now.year   = WOBJ_TimeYear(time);
	now.month  = WOBJ_TimeMonth(time);
	now.day    = WOBJ_TimeDay(time);
	now.hour   = WOBJ_TimeHour(time);
	now.minute = WOBJ_TimeMinute(time);
	now.second = WOBJ_TimeSecond(time);
	seconds = TimDateTimeToSeconds(&now);
	TimSetSeconds(seconds);
}
//////////////////////////////////////////////////////////////////////////
// modified by Jason Shutay to add support to the doWait parameter
// waba/sys/Vm static int vmExec(String command, String args, int launchCode, boolean wait)
void VmExec(Var stack[]) // (Ljava/lang/String;Ljava/lang/String;IZ)I
{
   WObject pathString, argsString;
   UtfString path, args;
   LocalID localID;
   Word launchCode;
   CharPtr s;
   int32 doWait; //RKK20000305
   UInt launchFlags; //RKK20000306
   DWord result; //RKK20000305

   pathString = stack[0].obj;
   argsString = stack[1].obj;
   launchCode = (Word)stack[2].intValue;
   doWait = stack[3].intValue; //RKK20000305
   launchFlags = 0; //RKK20000306

   // NOTE: we could use static here since we call stringToUtf twice
   // but before the second call, the path is no longer needed
   path = (*vmGlobals->stringToUtf)(pathString, STU_NULL_TERMINATE);
   if (path.len == 0)
      RETURN32(-1)
   localID = DmFindDatabase(0, path.str);
   if (!localID)
      RETURN32(-1)
   args = (*vmGlobals->stringToUtf)(argsString, STU_NULL_TERMINATE | STU_USE_STATIC);
   s = NULL;
   if (args.len > 0)
   {
      s = MemPtrNew(args.len + 1);
      StrCopy(s, args.str);
      MemPtrSetOwner(s, 0);
   }
   if (launchCode == 0)
      launchCode = sysAppLaunchCmdNormalLaunch;
   if (doWait == 0) //RKK20000305
      RETURN32(SysUIAppSwitch(0, localID, launchCode, s))
   else //RKK20000305
      RETURN32(SysAppLaunch(0, localID, launchFlags, launchCode, s, &result)) //RKK20000305
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Vm static int vmSetDeviceAutoOff(int seconds)
void VmSetDeviceAutoOff(Var stack[]) // (I)I
{
	RETURN32(SysSetAutoOffTime(stack[0].intValue))
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Vm static void vmSleep(int millis)
void VmSleep(Var stack[]) // (I)V
{
	uint32 t = (*vmGlobals->millisToTicks)(stack[0].intValue);
   SemaphoreRelease(1);	 // guich@400_13
	SysTaskDelay(t);
   SemaphoreReserve(1);
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Vm static void vmGC()
void VmGC(Var stack[]) // ()V
{
   (*vmGlobals->gc)();
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Vm static int vmGetDeviceFreeMemory()
void VmGetDeviceFreeMemory(Var stack[]) // ()I
{
   UInt32 freeBytesP;
#ifdef USE_STORAGE_HEAP
   MemCardInfo (0, 0,0,0,0,0,0, &freeBytesP); // since the class heap memory now grows, we return the hole free memory in the device
#else
   uint32 maxP; // guich@340_56
   MemHeapFreeBytes (0, &freeBytesP, &maxP);
#endif
	RETURN32(freeBytesP)
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Vm static void vmInterceptSystemKeys(int keys)
void VmInterceptSystemKeys(Var stack[]) // (I)V
{
   vmGlobals->interceptSystemKey = stack[0].intValue;
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Vm static void vmDebug(String s)
void VmDebug(Var stack[]) // (Ljava/lang/String;)V
{
	UtfString s;
	s = (*vmGlobals->stringToUtf)(stack[0].obj, STU_USE_STATIC | STU_NULL_TERMINATE);
	(*vmGlobals->debug)(s.str);
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Vm static void vmClipboardCopy(String s)
void VmClipboardCopy(Var stack[]) // (Ljava/lang/String;)V
{
	UtfString s = (*vmGlobals->stringToUtf)(stack[0].obj, STU_USE_STATIC | STU_NULL_TERMINATE);
   ClipboardAddItem(clipboardText,s.str, s.len);
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Vm static String vmClipboardPaste()
void VmClipboardPaste(Var stack[]) // ()Ljava/lang/String;
{
   unsigned short len;
   WObject obj;
   VoidHand ch = ClipboardGetItem(clipboardText, &len);
   if (ch && len)
   {
      obj = (*vmGlobals->createStringFromCharPtr)(MemHandleLock(ch),len);
      MemHandleUnlock(ch);
   } else obj = (*vmGlobals->createString)("");
	RETURN32(obj)
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Vm static boolean vmAttachLibrary(String name)
void VmAttachLibrary(Var stack[]) // (Ljava/lang/String;)Z
{
	DmSearchStateType state;
	LocalID dbID;
	UInt cardNo;
	Err err;
	Boolean first=true;
	UtfString s = (*vmGlobals->stringToUtf)(stack[0].obj, STU_USE_STATIC | STU_NULL_TERMINATE);
	char dbName[32];
	ULong creatorId = vmGlobals->appCreatorId?vmGlobals->appCreatorId:'SWAB';
	if (s.len > 5 && s.str[s.len-5] == '.') // guich@200b4_117: has a different creator id?
	{
	   creatorId = getCreator(&s.str[s.len-4]);
	   s.len -= 5;
	   s.str[s.len] =0;
	}

	// search for the database name given
	while (1)
	{
		err = DmGetNextDatabaseByTypeCreator(first, &state, SUPERWABA_TYPE_EXT, creatorId, false, &cardNo, &dbID);
		if (err == dmErrCantFind)
			break;
	 	if (DmDatabaseInfo(cardNo, dbID, dbName, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL) == 0 && !xstrncmp(dbName,s.str,s.len))
	 	{
         // ok, we found the library.
         int insertIndex;
         vmGlobals->classDbList = (DmOpenRef *)(*vmGlobals->expandArray)((char *)vmGlobals->classDbList,sizeof(DmOpenRef),1,&insertIndex);
         if (insertIndex == -1)
            RETURN32(0)
         vmGlobals->classDbList[insertIndex] = DmOpenDatabase(cardNo, dbID, dmModeReadOnly);
         RETURN32(1) // everything ok.
      }
		first = false;
	}
	RETURN32(0)
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/Vm static boolean vmAttachNativeLibrary(String name)
void VmAttachNativeLibrary(Var stack[]) // (Ljava/lang/String;)Z
{
	DmSearchStateType state;
	LocalID dbID;
	UInt cardNo;
	Err err;
	Boolean first=true;
	UtfString s = (*vmGlobals->stringToUtf)(stack[0].obj, STU_USE_STATIC | STU_NULL_TERMINATE);
	char dbName[32];
	ULong creatorId;
	UInt refnum;

	// search for the database name given
	while (1)
	{
		err = DmGetNextDatabaseByTypeCreator(first, &state, SWLibTypeID, 0, false, &cardNo, &dbID);
		if (err == dmErrCantFind)
			break;
	 	if (DmDatabaseInfo(cardNo, dbID, dbName, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, &creatorId) == 0 && !xstrncmp(dbName,s.str,s.len))
	 	{
         // ok, we found the library. try to load it
         err = SysLibFind(s.str, &refnum);
      	if (err)
            err = SysLibLoad(SWLibTypeID, creatorId, &refnum);
         if (!err) // loaded ok?
         {
            int insertIndex;
            SWLibOpen(refnum, vmGlobals);
            vmGlobals->nativeLibs = (NativeLibPtr)(*vmGlobals->expandArray)((char *)vmGlobals->nativeLibs,sizeof(vmGlobals->nativeLibs[0]),1,&insertIndex);
            if (insertIndex == -1)
               RETURN32(0)
            vmGlobals->nativeLibs[insertIndex].ref = refnum;
            RETURN32(1) // everything ok.
         }
         break;
      }
		first = false;
	}
	RETURN32(0)
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/NativeMethods static byte[] vmGetFile(String name)
void VmGetFile(Var stack[]) // (Ljava/lang/String;)[B
{
	UtfString path;
	WObject pathString,obj;
	uint16 pathLen;
	uchar *p;
   uint32 size=0;

	pathString = stack[0].obj;
	path = (*vmGlobals->stringToUtf)(pathString, STU_USE_STATIC);
	if (path.len == 0)
		RETURN32(0)

	pathLen = (uint16)path.len;
	p = (*vmGlobals->lockWarpRec)(path.str, (uint16)path.len, &size);
	if (p == NULL)
		RETURN32(0)
   // create the byte array object
   obj = (*vmGlobals->createArrayObject)(8,size);
   if (obj != NULL)
      xmemmove((byte*)WOBJ_arrayStart(obj),p,size);
 	(*vmGlobals->unlockWarpRec)(p, pathLen);
   RETURN32(obj)
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/NativeMethods static void vmExitAndReboot()
void VmExitAndReboot(Var stack[]) // ()V
{
	vmGlobals->reboot = 1;
	(*vmGlobals->postStopEvent)(0);
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/NativeMethods static int vmGetSystemKeysPressed()
void VmGetSystemKeysPressed(Var stack[]) // ()I
{
	int32 ret;
	ret = KeyCurrentState();
#ifdef PALMOS5
   ret &= vmGlobals->fiveWay;
#endif
	RETURN32(ret)
}
//////////////////////////////////////////////////////////////////////////
// waba/sys/NativeMethods static int vmGetRemainingBattery()
void VmGetRemainingBattery(Var stack[]) // ()I
{
	byte perc;
	int32 ret;
	if (vmGlobals->romVersion < 0x03000000) // Palm 2.0 works in a dif way
	   ret = SysBatteryInfoV20(0,0,0,0,0,0)/3; // 3.00 volts is the max
	else
	{
	   SysBatteryInfo(0,0,0,0,0,0,&perc);
	   ret = perc;
	}
	if (ret > 100)
	   ret = 100;
	RETURN32(ret)
}
