/*********************************************************************************
 *  SuperWaba Virtual Machine, version 5                                         *
 *  Copyright (C) 2000-2005 SuperWaba Ltda.                                      *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  Please see the software license located at /license.txt for more details.    *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     SuperWaba Ltda.                                                           *
 *     Rua Padre Leonel Franca, 480, sala 27A                                    *
 *     Instituto Genesis - PUC-RIO                                               *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22451-000                                                            *
 *     E-mail: licensing@superwaba.com.br                                        *
 *********************************************************************************/

//////////////////////////////////////////////////////////////////////////
// waba/ui/Window static void windowCreate(Window obj)
void WindowCreate(Var stack[]) // (Lwaba/ui/Window;)V
{
	WObject win = stack[0].obj;
	WOBJ_ControlX(win) = 0;
	WOBJ_ControlY(win) = 0;
	WOBJ_ControlWidth(win) = MaxScreenX; // guich@210_10
	WOBJ_ControlHeight(win) = MaxScreenY;
}
//////////////////////////////////////////////////////////////////////////
//waba/ui/NativeMethods static void windowUpdateScreen()
void WindowUpdateScreen(Var stack[]) // ()V  - guich@500_12
{
}
//////////////////////////////////////////////////////////////////////////
#define VK_HIDE 10000
#define VK_ONTOP 10001
#define VK_ONBOTTOM 10002
byte isHandEra();
// waba/ui/Window static void windowSetStatePosition(Window obj, int x, int y)
void WindowSetStatePosition(Var stack[]) // (Lwaba/ui/Window;II)V
{
	int x = stack[1].intValue;
	int y = stack[2].intValue;

   if ((x+y) > 6000)
      (*vmGlobals->showSip)((int16)((x == VK_HIDE || y == VK_HIDE)?0:1), (int16)((x == VK_ONTOP || y == VK_ONTOP)?1:0));
   else
   {
      vmGlobals->stateX = x;
      vmGlobals->stateY = y;
      GsiSetLocation(vmGlobals->stateX,vmGlobals->stateY+2);
   }
}
//////////////////////////////////////////////////////////////////////////
// waba/ui/MainWindow static void mainWindowCreate(MainWindow obj)
void MainWindowCreate(Var stack[]) // (Lwaba/ui/MainWindow;)V
{
	//vmGlobals->globalMainWin = stack[0].obj;
}
//////////////////////////////////////////////////////////////////////////
// waba/ui/MainWindow static void mainWindowExit(int exitCode)
void MainWindowExit(Var /*stack*/[]) // (I)V
{
	(*vmGlobals->postStopEvent)(0); // see nmpalm_b.c
}
//////////////////////////////////////////////////////////////////////////
// waba/ui/MainWindow static void mainWindowSetTimerInterval(int milliseconds)
void MainWindowSetTimerInterval(Var stack[]) // (I)V
{
	vmGlobals->globalTimerInterval = stack[0].intValue;
	vmGlobals->globalTimerStart = (*vmGlobals->getTimeStamp)();
}
//////////////////////////////////////////////////////////////////////////
// waba/ui/MainWindow static String mainWindowGetCommandLine()
void MainWindowGetCommandLine(Var stack[]) // ()Ljava/lang/String;
{
	RETURN32((vmGlobals->commandLine && *vmGlobals->commandLine)?(*vmGlobals->createString)(vmGlobals->commandLine):0)
}
//////////////////////////////////////////////////////////////////////////
// waba/ui/NativeMethods void mainWindowSetThreadCount(int count)
void MainWindowSetThreadCount(Var stack[]) // (I)V
{
	vmGlobals->threadCount = stack[0].intValue;
}
//////////////////////////////////////////////////////////////////////////
// waba/ui/NativeMethods boolean eventIsAvailable()
void EventIsAvailable(Var stack[]) // ()Z
{
	RETURN32((*vmGlobals->eventIsAvailable)())
}
//////////////////////////////////////////////////////////////////////////
// waba/ui/NativeMethods void windowPumpEvents()
void WindowPumpEvents(Var stack[]) // ()V
{
 	if ((*vmGlobals->pumpEvents)(1) == -1)
 	{
 	   // just break the current program execution and fail gracefully
 	   (*vmGlobals->throwException)("waba/sys/AppExitException", "");
 	}
}
